SystemOrganization addCategory: #'Spec-Widgets'!
SystemOrganization addCategory: #'Spec-Widgets-Utilities'!

ComposableModel subclass: #ButtonModel
	instanceVariableNames: 'actionHolder labelHolder stateHolder enabledHolder actionPerformedHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!ButtonModel commentStamp: '<historical>' prior: 0!
A ButtonComposableModel is an applicative model which handle a basic button.

| b |
b:= ButtonComposableModel new.
b openWithSpec.
b labelHolder contents: 'Click me'.

self example!

!ButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/1/2012 13:44'!
internSpec

	^ {#PluggableButtonMorph.
	    		#on:getState:action:label:menu:. 	#model. #state. #action. #label. #nil.
			#getEnabledSelector:. 				#enabled.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!ButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/15/2011 14:42'!
title

	^ 'Button'! !

!ButtonModel methodsFor: 'morphic' stamp: 'SimonAllier 1/27/2012 11:42'!
action

	self morph ifNotNil: [:m | m takeKeyboardFocus ].
	self actionHolder contents value.
	" Here I set a dummy value just to make the holder raise an event "
	self actionPerformedHolder contents: nil.! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 01:33'!
action: aBlock

	self actionHolder contents: aBlock! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
actionHolder

	^ actionHolder! !

!ButtonModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 11:40'!
actionPerformedHolder
" I am a dummy holder used to announce that my action has been performed "
	^ actionPerformedHolder! !

!ButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/15/2011 14:48'!
enabled

	^ self enabledHolder contents! !

!ButtonModel methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 11:47'!
enabled: aBoolean
	
	^ self enabledHolder contents: aBoolean! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:47'!
enabledHolder

	^ enabledHolder! !

!ButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:53'!
eventStringForNextFocus

	^ '<right>'! !

!ButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:54'!
eventStringForPreviousFocus

	^ '<left>'! !

!ButtonModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 10:17'!
initialize
	"Initialization code for ButtonComposableModel"

	super initialize.

	actionHolder := [] asValueHolder.
	labelHolder := '' asValueHolder.
	stateHolder := true asValueHolder.
	enabledHolder := true asValueHolder.

	actionPerformedHolder := nil asValueHolder! !

!ButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/23/2012 19:03'!
keyStroke: anEvent fromMorph: aMorph

	anEvent keyString = '<space>'
		ifTrue: [ self action ].
		
	super keyStroke: anEvent fromMorph: aMorph! !

!ButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/15/2011 14:28'!
label

	^ self labelHolder contents! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 00:33'!
label: aString

	self labelHolder contents: aString! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
labelHolder

	^ labelHolder! !

!ButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/15/2011 14:10'!
state

	^ self stateHolder contents! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 00:59'!
state: aBoolean
	
	^ self stateHolder contents: aBoolean! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
stateHolder

	^ stateHolder! !

!ButtonModel methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 11:41'!
whenActionPerformedDo: aBlock

	self actionPerformedHolder whenChangedDo: aBlock! !

ComposableModel subclass: #CheckBoxModel
	instanceVariableNames: 'actionWhenActivatedHolder actionWhenDesactivatedHolder enabledHolder stateHolder labelClickableHolder labelHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!CheckBoxModel commentStamp: '<historical>' prior: 0!
A CheckboxModel is a spec model for Checkbox

The method privateSetState: is really private and should only be used by RadioButtonGroup

You can see self>>#example for an example

You can also have a look at CheckBoxExample for a full example of how to use them with a group.
!

!CheckBoxModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/21/2012 17:17'!
internSpec

	^ {#CheckboxMorph.
	    		#on:selected:changeSelected:. 	#model. #state. #state:.
			#label:.								{	#model. #label		}.
			#labelClickable:.					{	#model. #labelClickable}.
			#beCheckbox.
			#hResizing:. 						#shrinkWrap.
			#vResizing:. 						#shrinkWrap.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!CheckBoxModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
title

	^ 'Radio Button'! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
actionWhenActivatedHolder
	
	^ actionWhenActivatedHolder! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
actionWhenDesactivatedHolder
	
	^ actionWhenDesactivatedHolder! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
activationAction: aBlock

	"This method is used to set the action to perform when I am activated"
	self actionWhenActivatedHolder contents: aBlock! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/15/2012 18:31'!
click

	self toggleState! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
desactivationAction: aBlock

	"This method is used to set the action to perform when I am desactivated"
	self actionWhenDesactivatedHolder contents: aBlock! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
enabled: aBoolean

	self enabledHolder contents: aBoolean! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
enabledHolder
	
	^ enabledHolder! !

!CheckBoxModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:54'!
eventStringForNextFocus

	^ '<right>'! !

!CheckBoxModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/15/2012 17:17'!
eventStringForPreviousFocus

	^ '<left>'! !

!CheckBoxModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/21/2012 16:40'!
initialize
	"Initialization code for RadioButton"

	super initialize.
	
	actionWhenActivatedHolder := [] asValueHolder.
	actionWhenDesactivatedHolder := [] asValueHolder.
	enabledHolder := true asValueHolder.
	stateHolder := false asValueHolder.
	labelClickableHolder := true asValueHolder. 
	labelHolder := '' asValueHolder.
	stateHolder whenChangedDo: [:bool |
		bool
			ifTrue: actionWhenActivatedHolder contents
			ifFalse: actionWhenDesactivatedHolder contents.
		self changed: #state ].
	labelClickableHolder whenChangedDo: [:aBoolean |
		morph ifNotNil: [ morph labelClickable: aBoolean ]].
	labelHolder whenChangedDo: [:label |
		morph ifNotNil: [ morph label: label ]].
	! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/21/2012 16:39'!
label
	
	^ labelHolder contents! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/21/2012 16:39'!
label: aString

	labelHolder contents: aString.! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/21/2012 16:37'!
labelClickable

	^ labelClickableHolder contents! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/21/2012 16:38'!
labelClickable: aBoolean

	labelClickableHolder contents: aBoolean! !

!CheckBoxModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
state

	^ self stateHolder contents! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:07'!
state: aBoolean

	self stateHolder contents: aBoolean! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
stateHolder
	
	^ stateHolder! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/15/2012 18:31'!
toggleState

	self state: self state not! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
whenActivatedDo: aBlock

	"This method is used to propagate the event that I have been activated" 
	self stateHolder whenChangedDo: [:bool | bool ifTrue: aBlock ]! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
whenDesactivatedDo: aBlock

	"This method is used to propagate the event that I have been desactivated"
	self stateHolder whenChangedDo: [:bool | bool ifFalse: aBlock ]! !

ComposableModel subclass: #DropListModel
	instanceVariableNames: 'listHolder selectionHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!DropListModel commentStamp: '<historical>' prior: 0!
A DropListModel is a Spec model for drop lists.

I am assume there is a little problem on an empty list, but frankly, who creates an empty drop list ?!

!DropListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 11:03'!
internSpec

	^ {#DropList.
	    		#on:list:selected:changeSelected:. 	#model. #getList. #getIndex. #setIndex:.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!DropListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 13:21'!
title

	^ 'Drop List'! !

!DropListModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:54'!
eventStringForNextFocus

	^ '<right>'! !

!DropListModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:54'!
eventStringForPreviousFocus

	^ '<left>'! !

!DropListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/2/2012 13:33'!
getIndex

	^ self selectionHolder index contents! !

!DropListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/2/2012 14:45'!
getList

	^ self listHolder contents collect: #label! !

!DropListModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 14:51'!
initialize
	"Initialization code for DropListModel"

	super initialize.

	listHolder := {} asValueHolder.
	selectionHolder := SelectionValueHolder new.
	
	listHolder whenChangedDo: [ 
					self changed: #getList.
					self internalResetSelection. ].
				
	selectionHolder whenChangedDo: [ self changed: #getIndex ].
	self whenSelectedItemChanges: [:item | item value ]! !

!DropListModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2012 14:14'!
internalResetSelection

	self selectionHolder reset.
	self getList isEmpty not
		ifTrue: [ self setSelectedIndex: 1 ]! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:48'!
items: aList

	listHolder contents: aList! !

!DropListModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 13:29'!
listHolder
	
	^ listHolder! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 14:14'!
resetSelection

	self selectionHolder reset! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:37'!
selectedIndex
	"Useless method but it denies a better and more consistent API"

	^ self getIndex! !

!DropListModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2012 13:34'!
selectedIndexHolder

	^ self selectionHolder index! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:45'!
selectedItem

	^ self selectedItemHolder contents! !

!DropListModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2012 13:34'!
selectedItemHolder

	^ self selectionHolder selection! !

!DropListModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 13:29'!
selectionHolder
	
	^ selectionHolder! !

!DropListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/2/2012 14:45'!
setIndex: anIndex

	self selectionHolder index contents: anIndex.
	self selectionHolder selection contents: (self listHolder contents at: anIndex ifAbsent: [ nil ]).
	self changed: #getIndex! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 14:48'!
setSelectedIndex: anIndex

	| selection |
	selection := self listHolder contents at: anIndex ifAbsent: [ ^ self ].
	selectionHolder index contents: anIndex.
	selectionHolder selection contents: selection! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:46'!
setSelectedItem: anItem

	| index |
	index := self getList identityIndexOf: anItem ifAbsent: [ ^ self ].
	selectionHolder index contents: index.
	selectionHolder selection contents: anItem! !

!DropListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 13:46'!
whenSelectedItemChanges: aBlock

	self selectionHolder selection whenChangedDo: aBlock! !

!DropListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/9/2012 17:22'!
whenSelectionChanges: aBlock

	self selectionHolder whenChangedDo: aBlock.! !

!DropListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 13:47'!
whenSelectionIndexChanges: aBlock

	self selectionHolder index whenChangedDo: aBlock! !

ComposableModel subclass: #LabelModel
	instanceVariableNames: 'textHolder enabledHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!LabelModel commentStamp: '<historical>' prior: 0!
A LabelModel is a spec model for Labels!

!LabelModel class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/15/2012 20:27'!
internSpec

	^ {#Label.
			#model:. 				#model.
			#getEnabledSelector:.	#enabled.
			#getTextSelector:.		#getText.
			#vResizing:.			#shrinkWrap.
			#hResizing:.			#spaceFill.
			#eventHandler:.	{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!LabelModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/15/2012 15:37'!
title

	^ 'Label Morph'! !

!LabelModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/15/2012 15:43'!
disable

	self enabled: false! !

!LabelModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/15/2012 15:43'!
enable

	self enabled: true! !

!LabelModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/15/2012 15:42'!
enabled

	^ enabledHolder contents! !

!LabelModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/15/2012 15:43'!
enabled: aBoolean

	enabledHolder contents: aBoolean! !

!LabelModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/15/2012 15:42'!
getText

	^ textHolder contents! !

!LabelModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/15/2012 15:42'!
initialize
	"Initialization code for LabelModel"

	super initialize.

	textHolder := '' asValueHolder.
	enabledHolder := true asValueHolder.
	textHolder whenChangedDo: [ self changed: #getText ].
	enabledHolder whenChangedDo: [ self changed: #enabled ].! !

!LabelModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/15/2012 15:43'!
text: aText

	textHolder contents: aText! !

ComposableModel subclass: #ListComposableModel
	instanceVariableNames: 'selectionHolder listHolder wrapHolder menuHolder shortcutsHolder multiSelectionHolder multiSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!ListComposableModel commentStamp: '<historical>' prior: 0!
A ListComposableModel is an applicative model which handle a basic list.

| t |
t:= ListComposableModel new.
t openWithSpec.
t items: (Smalltalk allClasses).
self example!

ListComposableModel subclass: #IconListModel
	instanceVariableNames: 'iconHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!IconListModel commentStamp: '<historical>' prior: 0!
An IconListModel is a spec model for icon list!

!IconListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/10/2012 17:58'!
internSpec

	^ {#IconList.
	    		#model:. 						#model.
			#getListSizeSelector:. 			#listSize.
			#getListElementSelector:. 		#listElementAt:.
			#getListSelector:. 				#getList.
			#getIndexSelector:. 			#getIndex.
			#setIndexSelector:. 			#setIndex:.
			#getSelectionListSelector:.		#getSelectionStateFor:.
			#setSelectionListSelector:.		#setSelectionStateFor:at:.
			#getIconSelector:.				#getIconFor:.
			#resetListSelector:.			#resetListSelection.
			#getMenuSelector:.				#menu:shifted:.
			#keystrokeSelector:.			#keyStroke:fromMorph:.
			#setMultipleSelection:.			{#model. #multiSelection}.
			#wrapSelector:. 				#wrapItem:.
			#hResizing:. 					#spaceFill.
			#vResizing:. 					#spaceFill}! !

!IconListModel methodsFor: 'morphic' stamp: 'SimonAllier 2/10/2012 13:05'!
getIconFor: anItem

	^ iconHolder contents cull: anItem cull: self! !

!IconListModel methodsFor: 'protocol' stamp: 'SimonAllier 2/10/2012 13:06'!
icons: aBlock

	iconHolder contents: aBlock! !

!IconListModel methodsFor: 'initialization' stamp: 'SimonAllier 2/10/2012 13:06'!
initialize
	"Initialization code for IconListModel"

	super initialize.

	iconHolder := [:item | nil ] asValueHolder.! !

!ListComposableModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 12/15/2011 13:29'!
example
	| instance |

	instance := self new.
	instance openWithSpec.
	instance listHolder contents: (Smalltalk allClasses).! !

!ListComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/11/2012 20:09'!
internSpec

	^ {#List.
	    		#model:. 						#model.
			#getListSizeSelector:. 			#listSize.
			#getListElementSelector:. 		#listElementAt:.
			#getListSelector:. 				#getList.
			#getIndexSelector:. 			#getIndex.
			#setIndexSelector:. 			#setIndex:.
			#getSelectionListSelector:.		#getSelectionStateFor:.
			#setSelectionListSelector:.		#setSelectionStateFor:at:.
			#resetListSelector:.				#resetListSelection.
			#getMenuSelector:.			#menu:shifted:.
			#keystrokeSelector:.			#keyStroke:fromMorph:.
			#setMultipleSelection:.			{#model. #multiSelection}.
			#wrapSelector:. 				#wrapItem:.
			#hResizing:. 					#spaceFill.
			#vResizing:. 					#spaceFill}! !

!ListComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:09'!
title

	^ 'List'! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 16:15'!
beMultipleSelection

	self multiSelection: true! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 16:15'!
beSingleSelection

	self multiSelection: false! !

!ListComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:51'!
eventStringForNextFocus

	^ '<right>'! !

!ListComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:52'!
eventStringForPreviousFocus

	^ '<left>'! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:50'!
getIndex

	^ self selectionHolder index contents! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 1/9/2012 17:47'!
getList

	^ self listHolder contents ifNil: [ {} ]! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/9/2012 16:58'!
getSelectionStateFor: anIndex

	^ (multiSelectionHolder at: anIndex ifAbsent: [ ^ false ]) == true! !

!ListComposableModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 2/9/2012 17:21'!
initialize

	super initialize.
	selectionHolder := SelectionValueHolder new.
	listHolder := Array new asValueHolder.
	wrapHolder := [:object | object asStringOrText ] asValueHolder.
	menuHolder := [:menu :shifted | nil ] asValueHolder.
	shortcutsHolder := [:event :sourceMorph | ] asValueHolder.
	multiSelectionHolder := IdentityDictionary new asValueHolder.
	multiSelection := false.
	
	listHolder whenChangedDo: [ self changed: #getList ].
	selectionHolder whenChangedDo: [ self changed: #getIndex ].! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 00:48'!
items: aList

	listHolder contents: aList! !

!ListComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/21/2012 17:59'!
keyStroke: anEvent fromMorph: aMorph

	anEvent keyString = ' '
		ifTrue: [| item |
			item := self selectedItem. 
			(item notNil and: [ item respondsTo: #click ])
				ifTrue: [ ^ item click ]].

	self shortcutsHolder contents cull: anEvent cull: aMorph.

	^ super keyStroke: anEvent fromMorph: aMorph! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/10/2012 17:56'!
listElementAt: anIndex

	^ self listHolder contents at: anIndex! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
listHolder

	^ listHolder! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/19/2012 18:53'!
listSize

	^ self listHolder contents size! !

!ListComposableModel methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 12:25'!
menu: aBlock

	self menuHolder contents: aBlock! !

!ListComposableModel methodsFor: 'morphic' stamp: 'SimonAllier 1/27/2012 12:24'!
menu: aMenu shifted: aBoolean

	^ self menuHolder contents cull: aMenu cull: aBoolean! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
menuHolder

	^ menuHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 17:10'!
multiSelection

	^ multiSelection! !

!ListComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/9/2012 16:16'!
multiSelection: aBoolean

	multiSelection := aBoolean.
	morph ifNotNil: [ morph setMultipleSelection: multiSelection ]! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 16:22'!
multiSelectionHolder

	^ multiSelectionHolder! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/9/2012 16:59'!
resetListSelection

	multiSelectionHolder removeAll! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/7/2012 06:44'!
resetSelection

	self selectionHolder reset! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:36'!
selectedIndex
	"Useless method but it denies a better and more consistent API"

	^ self getIndex! !

!ListComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/31/2012 15:49'!
selectedIndexHolder

	^ self selectionHolder index! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:09'!
selectedIndexes
	
	^ multiSelectionHolder keys select: [:index | multiSelectionHolder at: index ]! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 02:15'!
selectedItem

	^ self selectedItemHolder contents! !

!ListComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/16/2012 01:49'!
selectedItemHolder

	^ self selectionHolder selection! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:09'!
selectedItems

	^ multiSelectionHolder keys select: [:index | multiSelectionHolder at: index ] thenCollect: [:index | self getList at: index ]! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
selectionHolder

	^ selectionHolder! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:50'!
setIndex: anIndex

	self selectionHolder index contents: anIndex.
	self selectionHolder selection contents: (self getList at: anIndex ifAbsent: [ nil ]).
	self changed: #getIndex! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/11/2012 20:44'!
setSelectedIndex: anIndex

	| idx selection |
	idx := anIndex min: self listSize.
	selection := self getList at: idx ifAbsent: [ ^ self ].
	selectionHolder index contents: idx.
	selectionHolder selection contents: selection! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 00:48'!
setSelectedItem: anItem

	| index |
	index := self getList identityIndexOf: anItem ifAbsent: [ ^ self ].
	selectionHolder index contents: index.
	selectionHolder selection contents: anItem! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/9/2012 17:00'!
setSelectionStateFor: anIndex at: aBoolean

	^ multiSelectionHolder at: anIndex put: aBoolean! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 10:48'!
shortcuts: aBlock

	self shortcutsHolder contents: aBlock! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/7/2012 10:24'!
shortcutsHolder

	^ shortcutsHolder! !

!ListComposableModel methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 12:09'!
updateList

	self changed: #getList.
	self resetSelection! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/5/2012 16:03'!
whenListChanges: aBlock

	self listHolder whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 1/16/2012 02:02'!
whenSelectedItemChanges: aBlock

	self selectionHolder selection whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/9/2012 17:22'!
whenSelectionChanges: aBlock

	self selectionHolder whenChangedDo: aBlock.
	self multiSelectionHolder whenChangedDo: aBlock.! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 1/16/2012 02:08'!
whenSelectionIndexChanges: aBlock

	self selectionHolder index whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
wrapHolder

	^ wrapHolder! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:35'!
wrapItem: anObject

	^ self wrapHolder contents value: anObject! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 00:47'!
wrappingBlock: aBlock

	wrapHolder contents: aBlock! !

ListComposableModel subclass: #MultiColumnListModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!MultiColumnListModel commentStamp: '<historical>' prior: 0!
A MultiColumnListModel is a spec model for Multi columns list!

!MultiColumnListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/19/2012 20:05'!
internSpec

	^ {#MultiColumnList.
			#wrapSelector:. 				#wrapItem:.
	    		#model:. 						#model.
			#getListSizeSelector:. 			#listSize.
			#getListElementSelector:. 		#listElementAt:.
			#getListSelector:. 				#getList.
			#getIndexSelector:. 			#getIndex.
			#setIndexSelector:. 			#setIndex:.
			#getSelectionListSelector:.		#getSelectionStateFor:.
			#setSelectionListSelector:.		#setSelectionStateFor:at:.
			#resetListSelector:.				#resetListSelection.
			#getMenuSelector:.			#menu:shifted:.
			#keystrokeSelector:.			#keyStroke:fromMorph:.
			#setMultipleSelection:.			{#model. #multiSelection}.
			#hResizing:. 					#spaceFill.
			#vResizing:. 					#spaceFill}! !

!MultiColumnListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/19/2012 18:24'!
listElementAt: anIndex

	^ self wrapItem: (self listHolder contents at: anIndex)! !

ComposableModel subclass: #PickListModel
	instanceVariableNames: 'listModel wrapHolder associations pickedItemsHolder defaultValueHolder labelClickableHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!PickListModel commentStamp: '<historical>' prior: 0!
A PickList is a tick list done using spec.!

!PickListModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/21/2012 16:31'!
example
	"self example"
	| instance |
	
	instance := self new.
	instance openWithSpec.
	instance items: { {1. 2. 4}. 'Foo'. 123}! !

!PickListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/15/2012 16:20'!
internSpec

	^{#model. #listModel. #internSpec}! !

!PickListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/21/2012 16:30'!
title

	^ 'Pick List Example'! !

!PickListModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/18/2012 02:55'!
addPicked: item

	pickedItemsHolder contents add: item.
	pickedItemsHolder contentsChanged.! !

!PickListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/21/2012 16:34'!
defaultValue

	^ defaultValueHolder contents! !

!PickListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/18/2012 03:17'!
defaultValue: aBoolean

	defaultValueHolder contents: aBoolean! !

!PickListModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/21/2012 16:33'!
initialize
	"Initialization code for PickList"

	super initialize.

	listModel := self instantiate: ListComposableModel.
	wrapHolder := [ :i | i printString ] asValueHolder. 
	pickedItemsHolder := Set new asValueHolder.
	associations := Dictionary new.
	labelClickableHolder := true asValueHolder.
	
	listModel whenListChanges: [ self focusOrder removeAll ].
	listModel wrappingBlock: [ :item | item ].
	labelClickableHolder whenChangedDo: [:aBoolean | 
		associations keys do: [:e | e labelClickable: aBoolean ]].
	defaultValueHolder := false asValueHolder.
	defaultValueHolder whenChangedDo: [:value | associations keysDo: [:cb | cb state: value ]].! !

!PickListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/18/2012 04:05'!
items: aCollection

	associations removeAll.
	pickedItemsHolder contents removeAll.
	pickedItemsHolder contentsChanged.
	listModel items: (aCollection collect: [:e | self wrap: e ]).! !

!PickListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/21/2012 16:35'!
labelClickable
	
	^ labelClickableHolder contents! !

!PickListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/21/2012 16:34'!
labelClickable: aBoolean

	labelClickableHolder contents: aBoolean! !

!PickListModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/15/2012 16:55'!
listModel

	^ listModel! !

!PickListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/18/2012 03:49'!
pickedItems

	^ pickedItemsHolder contents! !

!PickListModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/18/2012 03:27'!
removePicked: item

	pickedItemsHolder contents remove: item ifAbsent: [ ^ self ].
	pickedItemsHolder contentsChanged.! !

!PickListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/18/2012 02:41'!
selectedIndex

	^ listModel selectedIndex! !

!PickListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/18/2012 02:41'!
selectedItem

	^ associations 
		at: listModel selectedItem
		ifAbsent: [ nil ]! !

!PickListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/18/2012 02:52'!
whenListChanges: aBlock

	listModel whenListChanges: aBlock! !

!PickListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/18/2012 02:55'!
whenPickedItemsChanges: aBlock

	pickedItemsHolder whenChangedDo: aBlock! !

!PickListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/18/2012 03:02'!
whenSelectedItemChanges: aBlock
	| newBlock |
	
	newBlock := [ :item | aBlock cull: (associations at: item ifAbsent: [ nil ])].
	listModel whenSelectedItemChanges: newBlock! !

!PickListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/18/2012 02:53'!
whenSelectionChanges: aBlock

	listModel whenSelectionChanges: aBlock! !

!PickListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/18/2012 02:53'!
whenSelectionIndexChanges: aBlock

	listModel whenSelectionIndexChanges: aBlock! !

!PickListModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/21/2012 16:35'!
wrap: item
	| checkBox |

	checkBox := self instantiate: CheckBoxModel.
	checkBox label: (self wrapHolder contents cull: item cull: self).
	checkBox whenActivatedDo: [ 
		self addPicked: item.
		listModel setSelectedItem: checkBox.
		listModel takeKeyboardFocus ].
	checkBox whenDesactivatedDo: [ 
		self removePicked: item.
		listModel setSelectedItem: checkBox.
		listModel takeKeyboardFocus ].
	checkBox 
		state: self defaultValue;
		labelClickable: self labelClickable.
	associations at: checkBox put: item.
	^ checkBox! !

!PickListModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/15/2012 16:55'!
wrapHolder

	^ wrapHolder! !

!PickListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/15/2012 16:54'!
wrappingBlock: aBlock

	wrapHolder contents: aBlock! !

ComposableModel subclass: #RadioButtonModel
	instanceVariableNames: 'actionWhenActivatedHolder actionWhenDesactivatedHolder enabledHolder stateHolder label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!RadioButtonModel commentStamp: '<historical>' prior: 0!
A RadioButtonModel is a spec model for RadioButton

!! The method privateSetState: is really private and should only be used by RadioButtonGroup !!

You can also have a look at RadioButtonGroupExample for a full example of how to use them with a group.!

!RadioButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/15/2012 20:28'!
internSpec

	^ {#Checkbox.
	    		#on:selected:changeSelected:. 	#model. #state. #state:.
			#label:.								{	#model. #label		}.
			#beRadioButton.
			#hResizing:. 						#shrinkWrap.
			#vResizing:. 						#shrinkWrap.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!RadioButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/1/2012 13:35'!
title

	^ 'Radio Button'! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 13:49'!
actionWhenActivatedHolder
	
	^ actionWhenActivatedHolder! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 13:49'!
actionWhenDesactivatedHolder
	
	^ actionWhenDesactivatedHolder! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 17:44'!
activationAction: aBlock

	"This method is used to set the action to perform when I am activated"
	self actionWhenActivatedHolder contents: aBlock! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 17:44'!
desactivationAction: aBlock

	"This method is used to set the action to perform when I am desactivated"
	self actionWhenDesactivatedHolder contents: aBlock! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 13:27'!
enabled: aBoolean

	self enabledHolder contents: aBoolean! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 13:49'!
enabledHolder
	
	^ enabledHolder! !

!RadioButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:55'!
eventStringForNextFocus

	^ '<right>'! !

!RadioButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:55'!
eventStringForPreviousFocus

	^ '<left>'! !

!RadioButtonModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/1/2012 17:39'!
initialize
	"Initialization code for RadioButton"

	super initialize.
	
	actionWhenActivatedHolder := [] asValueHolder.
	actionWhenDesactivatedHolder := [] asValueHolder.
	enabledHolder := true asValueHolder.
	stateHolder := true asValueHolder.
	stateHolder whenChangedDo: [:bool |
		bool
			ifTrue: actionWhenActivatedHolder contents
			ifFalse: actionWhenDesactivatedHolder contents ].! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:57'!
label
	
	^ label! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 17:56'!
label: aString

	label := aString.
	self morph
		ifNotNil: [:m | m label: label ]! !

!RadioButtonModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2012 00:57'!
privateSetState: aBoolean

	self stateHolder contents: aBoolean.
	self changed: #state! !

!RadioButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/1/2012 13:44'!
state

	^ self stateHolder contents! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 14:03'!
state: aBoolean

	self state
		ifFalse: [ self stateHolder contents: true ].! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 13:49'!
stateHolder
	
	^ stateHolder! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/1/2012 18:00'!
whenActivatedDo: aBlock

	"This method is used to propagate the event that I have been activated" 
	self stateHolder whenChangedDo: [:bool | bool ifTrue: aBlock ]! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/1/2012 18:00'!
whenDesactivatedDo: aBlock

	"This method is used to propagate the event that I have been desactivated"
	self stateHolder whenChangedDo: [:bool | bool ifFalse: aBlock ]! !

ComposableModel subclass: #TextInputFieldModel
	instanceVariableNames: 'textHolder actionToPerformHolder ghostText alwaysAccept acceptOnCR autoAccept entryCompletion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!TextInputFieldModel commentStamp: '<historical>' prior: 0!
A TextInputFieldModel is a spec model for TextInputField.!

!TextInputFieldModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/4/2012 14:46'!
example
	| instance |
	
	instance := self new.
	instance openWithSpec.
	instance ghostText: 'This is a ghost'.
	instance text: 'This is a text'! !

!TextInputFieldModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/15/2012 20:28'!
internSpec

	^ {#TextField.
			#convertTo:. 							String.
			#on:text:accept:readSelection:menu:. 	#model. #getText. #accept:. nil. nil.
			#entryCompletion:. 				{	#model. #entryCompletion	}.
			#autoAccept:.						{	#model. 	#autoAccept			}.	
			#acceptOnCR:. 					{	#model. 	#acceptOnCR			}.
			#ghostText:.						{	#model. 	#ghostText			}.
			#hResizing:. 							#spaceFill.
			#vResizing:. 							#shrinkWrap.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!TextInputFieldModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
title

	^ 'Text'! !

!TextInputFieldModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
accept: aText

	self textHolder contents: aText.
	self actionToPerformHolder contents cull: aText.
	self changed: #clearUserEdits.! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:21'!
acceptOnCR

	^ acceptOnCR! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:21'!
acceptOnCR: aBoolean

	acceptOnCR := aBoolean
	self morph ifNotNil: [:m | m acceptOnCR: acceptOnCR ]! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:36'!
action: aBlockWithOneArgument

	actionToPerformHolder contents: aBlockWithOneArgument! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
actionToPerformHolder

	^ actionToPerformHolder! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:23'!
autoAccept

	^ autoAccept! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:25'!
autoAccept: aBoolean

	autoAccept := aBoolean.
	self morph ifNotNil: [:m | m autoAccept: autoAccept ]! !

!TextInputFieldModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/4/2012 14:45'!
defaultEntryCompletion

	| applicants |
	applicants := (Array
				streamContents: [:strm | Symbol
						allSymbolTablesDo: [:each | (each notEmpty
									and: [each first canBeGlobalVarInitial
											and: [Smalltalk globals includesKey: each]])
								ifTrue: [strm nextPut: each]]]) sort.

	^ EntryCompletion new
				dataSourceBlock: [:currText | applicants];
				filterBlock: [:currApplicant :currText | currText size > 3
						and: [currApplicant asUppercase includesSubString: currText asString asUppercase]].! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:45'!
entryCompletion

	^ entryCompletion! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:45'!
entryCompletion: anEntryCompletion

	entryCompletion := anEntryCompletion.
	self morph ifNotNil: [:m | m entryCompletion: entryCompletion ]! !

!TextInputFieldModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:55'!
eventStringForNextFocus

	^ '<Ctrl-Cmd-right>'! !

!TextInputFieldModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:55'!
eventStringForPreviousFocus

	^ '<Ctrl-Cmd-left>'! !

!TextInputFieldModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/4/2012 11:20'!
getText
	
	^ self textHolder contents! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 12:02'!
ghostText

	^ ghostText! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 11:37'!
ghostText: aText

	ghostText := aText translated.
	self morph ifNotNil: [:m | m ghostText: ghostText ]! !

!TextInputFieldModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 10:16'!
initialize
	"Initialization code for TextComposableModel"

	super initialize.

	textHolder := '' asValueHolder.
	actionToPerformHolder := [:text | ] asValueHolder.
	
	ghostText := ''.
	acceptOnCR := true.
	autoAccept := false.! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 17:31'!
okToChange

	self canDiscardEdits ifTrue: [^ true].
	self changed: #wantToChange.  "Solicit cancel from view"
	^ self canDiscardEdits! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:45'!
removeEntryCompletion

	self entryCompletion: nil! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
setSelection: anInterval

	self morph setSelection: anInterval! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
text: aText

	textHolder contents: aText! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
textHolder

	^ textHolder! !

ComposableModel subclass: #TextModel
	instanceVariableNames: 'aboutToStyleHolder behaviorHolder textHolder actionToPerformHolder readSelectionHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!TextModel commentStamp: '<historical>' prior: 0!
A TextComposableModel is an applicative model which handle a basic text.

| t |
t:= TextComposableModel new.
t openWithSpec.
t textHolder contents: 'This is a test'.

self example!

!TextModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/4/2012 14:46'!
example
	| instance |
	
	instance := self new.
	instance openWithSpec.
	instance text: 'This is a test'.! !

!TextModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/21/2012 18:53'!
internSpec

	^ {#PluggableTextMorph.
	    		#on:text:accept:readSelection:menu:. 	#model. #getText. #accept:notifying:. #readSelection. #codePaneMenu:shifted:.
			#classOrMetaClass:.					{ #model. #behavior}.
			#hResizing:. 							#spaceFill.
			#vResizing:. 							#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!TextModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/13/2011 23:31'!
title

	^ 'Text'! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 22:59'!
aboutToStyle: aBoolean	

	aboutToStyleHolder contents: [ aBoolean ]! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 22:58'!
aboutToStyleBlock: aBlockReturningABoolean	

	aboutToStyleHolder contents: aBlockReturningABoolean! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 00:06'!
aboutToStyleHolder

	^ aboutToStyleHolder! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/11/2012 20:47'!
accept: aText notifying: aNotifyier

	self textHolder contents: aText.
	self actionToPerformHolder contents cull: aText cull: aNotifyier.
	self changed: #clearUserEdits.! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:36'!
action: aBlockWithOneArgument

	actionToPerformHolder contents: aBlockWithOneArgument! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 00:08'!
actionToPerformHolder

	^ actionToPerformHolder! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/21/2012 18:34'!
behavior

	^ behaviorHolder contents! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 02:15'!
behavior: aText

	behaviorHolder contents: aText! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:41'!
behaviorHolder

	^ behaviorHolder! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/11/2012 21:01'!
clearUserEditFlag
	
	self text: self getText.
	self changed: #clearUserEdits! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/21/2012 17:08'!
codePaneMenu: aMenu shifted: shifted 
	"Note that unless we override perform:orSendTo:, 
	PluggableTextController will respond to all menu items in a 
	text pane"
	
	^ shifted
			ifTrue: [SmalltalkEditor shiftedYellowButtonMenu]
			ifFalse: [SmalltalkEditor yellowButtonMenu].! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:17'!
doItContext

	^ nil! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:17'!
doItReceiver

	^ self selectedBehavior
		ifNil: [ nil ]
		ifNotNil: [:class | class theNonMetaClass ]! !

!TextModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:55'!
eventStringForNextFocus

	^ '<Ctrl-Cmd-right>'! !

!TextModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:55'!
eventStringForPreviousFocus

	^ '<Ctrl-Cmd-left>'! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 17:26'!
getText
	
	^ self textHolder contents! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/11/2012 21:07'!
hasEditingConflicts

	^ morph 
		ifNil: [ false ]
		ifNotNil: [ morph hasEditingConflicts ]! !

!TextModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/21/2012 19:03'!
initialize
	"Initialization code for TextComposableModel"

	super initialize.

	textHolder := '' asValueHolder.
	behaviorHolder := nil asValueHolder.
	aboutToStyleHolder := [ false ] asValueHolder.
	actionToPerformHolder := [:text | ] asValueHolder.
	readSelectionHolder := [ 1 to: 0 ] asValueHolder.
	
	textHolder whenChangedDo: [ self changed: #getText ].
	aboutToStyleHolder whenChangedDo: [ self changed: #getText ].
	readSelectionHolder whenChangedDo: [ self changed: #readSelection ].
	behaviorHolder whenChangedDo: [:class |
		morph ifNotNil: [:mrph | mrph classOrMetaClass: class ].
		self changed: #getText ].! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/11/2012 21:00'!
okToChange

	self canDiscardEdits ifTrue: [^ true].
	self changed: #wantToChange.  "Solicit cancel from view"
	^ self canDiscardEdits! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:09'!
okToStyle

	^ true! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/11/2012 20:55'!
pendingText

	self morph
		ifNil: [ ^ self getText ]
		ifNotNil: [ ^ morph text ]! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/11/2012 21:31'!
pendingText: aText

	self morph
		ifNil: [ self text: aText ]
		ifNotNil: [ 
			morph setText: aText.
			morph hasUnacceptedEdits: true ]! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/21/2012 17:19'!
readSelection

	^ readSelectionHolder contents cull: (morph ifNil: [ nil ] ifNotNil: [ morph text ]) cull: self! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/21/2012 17:10'!
readSelectionBlock

	^ readSelectionHolder contents! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/21/2012 17:10'!
readSelectionBlock: aBlock

	^ readSelectionHolder contents: aBlock! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:14'!
selectedBehavior

	^ self behaviorHolder contents! !

!TextModel methodsFor: 'protocol' stamp: 'SimonAllier 1/24/2012 16:58'!
setSelection: anInterval

	self morph setSelection: anInterval! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:21'!
shoutAboutToStyle: aMorph
	
	^ self aboutToStyleHolder contents value! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/15/2012 23:26'!
text: aText

	textHolder contents: aText! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:41'!
textHolder

	^ textHolder! !

Object subclass: #DropListItem
	instanceVariableNames: 'actionHolder label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets-Utilities'!

!DropListItem commentStamp: '<historical>' prior: 0!
A DropListItem is an item (wrapper) designed to fit into a DropList!

!DropListItem class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/2/2012 15:17'!
example

	| b |
	b:= DropListModel new.
	b openWithSpec.
	b items: { 	DropListItem named: 'label 1' do: [:label | label inspect ].
				DropListItem named: 'label 2' do: [:label | label inspect ].
				DropListItem named: 'label 3' do: [:label | label inspect ].
				DropListItem named: 'label 4' do: [:label | label inspect ]}.

	b whenSelectedItemChanges: [:item | item inspect ]! !

!DropListItem class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/2/2012 14:51'!
named: label do: aBlock

	^ self new
		action: aBlock;
		label: label;
		yourself! !

!DropListItem methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 14:51'!
action: aBlock

	self actionHolder contents: aBlock! !

!DropListItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 14:43'!
actionHolder
	
	^ actionHolder! !

!DropListItem methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 14:50'!
initialize
	"Initialization code for DropListItem"

	super initialize.

	actionHolder := [] asValueHolder.
	label := ''.! !

!DropListItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 14:43'!
label
	
	^ label! !

!DropListItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 14:43'!
label: anObject
	
	label := anObject! !

!DropListItem methodsFor: 'execution' stamp: 'BenjaminVanRyseghem 2/2/2012 14:52'!
value
	"This way, I am polymorphic with nil"

	self actionHolder contents cull: self label cull: self! !

Object subclass: #MorphWrapper
	instanceVariableNames: 'layout morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets-Utilities'!

!MorphWrapper commentStamp: '<historical>' prior: 0!
A MorphWrapper is used to wrap a morph with a layout in the goal to be easily added to another morph!

!MorphWrapper class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/14/2011 16:27'!
morph: morph layout: layout 

	^ self new
		layout: layout;
		morph: morph;
		yourself! !

!MorphWrapper methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 2/10/2012 14:52'!
addIn: aContainer
		
	aContainer
		addMorph: morph
		fullFrame: layout! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:38'!
frame: relFrame
	| frame |
	frame := LayoutFrame new.
	frame 
		leftFraction: relFrame left; 
		rightFraction: relFrame right; 
		topFraction: relFrame top; 
		bottomFraction: relFrame bottom.
	layout := frame! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:38'!
fullFrame: anObject
	
	layout := anObject! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:27'!
morph: anObject
	
	morph := anObject! !

Object subclass: #RadioButtonGroup
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets-Utilities'!

!RadioButtonGroup commentStamp: '<historical>' prior: 0!
A RadioButtonGroup is a group for radio buttons which ensure that only radio button of this group is activated at the same time.!

!RadioButtonGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:02'!
addRadioButton: aButton

	buttons do: [:b | 
		aButton whenActivatedDo: [ b privateSetState: false ].
		b whenActivatedDo: [ aButton privateSetState: false ]].
		
	buttons add: aButton.
	aButton privateSetState: false! !

!RadioButtonGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:03'!
default: aButton

	aButton privateSetState: true.
	aButton takeKeyboardFocus.! !

!RadioButtonGroup methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/1/2012 17:35'!
initialize
	"Initialization code for RadioButtonGroup"

	super initialize.

	buttons := OrderedCollection new.! !

PanelMorph subclass: #PanelMorphWithSplitters
	instanceVariableNames: 'paneMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets-Utilities'!

!PanelMorphWithSplitters commentStamp: '<historical>' prior: 0!
A PanelMorphWithSplitters is which add splitters the way SystemWindow do it!

!PanelMorphWithSplitters methodsFor: 'submorphs-add/remove' stamp: 'BenjaminVanRyseghem 2/10/2012 15:18'!
addMorph: aMorph fullFrame: aLayout

	paneMorphs add: aMorph.
	super addMorph: aMorph fullFrame: aLayout! !

!PanelMorphWithSplitters methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 14:55'!
addPaneHSplitterBetween: topMorphs and: bottomMorphs
	"Add a horizontal splitter for the given morphs that share a common bottom fraction.
	If there is a horizontal discontinuity apply the splitter to the first contiguous group.
	Answer the morphs to which the splitter was applied."
	
	|targetY fixed rightFraction leftFrame rightFrame sorted morph topGroup bottomGroup splitter offset|
	topMorphs ifEmpty: [^self].
	targetY := topMorphs first layoutFrame bottomFraction.
	fixed := topMorphs select: [:m | m layoutFrame topFraction = m layoutFrame bottomFraction].
		"fixed morphs appear in both top and bottom"
	sorted := ((topMorphs reject: [:m | m layoutFrame topFraction = m layoutFrame bottomFraction])
		asSortedCollection: [:a :b | a layoutFrame rightFraction = b layoutFrame rightFraction
			ifTrue: [a layoutFrame leftFraction <= b layoutFrame leftFraction]
			ifFalse: [a layoutFrame rightFraction <= b layoutFrame rightFraction]]) readStream.
	sorted contents ifEmpty: [^fixed].
	topGroup := OrderedCollection new.
	rightFraction := sorted contents first layoutFrame leftFraction.
	[sorted atEnd or: [morph := sorted next.
			(morph layoutFrame leftFraction ~= rightFraction and: [
				morph layoutFrame rightFraction ~= rightFraction])]] whileFalse: [
		topGroup add: morph.
		rightFraction := morph layoutFrame rightFraction].
	leftFrame := topGroup first layoutFrame.
	rightFrame := topGroup last layoutFrame.
	bottomGroup := (bottomMorphs 
			reject: [:m | m layoutFrame topFraction = m layoutFrame bottomFraction])
			select: [:m |
		(m layoutFrame leftFraction
			between: leftFrame leftFraction
			and: rightFrame rightFraction) or: [
		m layoutFrame rightFraction
			between: leftFrame leftFraction
			and: rightFrame rightFraction]].
	offset := (topGroup collect: [:m | m layoutFrame bottomOffset ifNil: [0]]) max.
	splitter := ProportionalSplitterMorph new
		beSplitsTopAndBottom.
	splitter layoutFrame: (LayoutFrame
		fractions: (leftFrame leftFraction @ targetY
					corner: rightFrame rightFraction @ targetY)
		offsets: (((leftFrame leftOffset ifNil: [0]) @ 0 corner: ((rightFrame rightOffset ifNil: [0])@ 4))
		 	translateBy: 0 @ offset)).
	topGroup := topGroup, fixed.
	topGroup do: [:m | splitter addLeftOrTop: m].
	bottomGroup do: [:m | splitter addRightOrBottom: m].
	self addMorphBack: splitter.
	^topGroup! !

!PanelMorphWithSplitters methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 14:54'!
addPaneHSplitters
	"Add the horizontal pane splitters."

	|remaining targetBottom sameBottom sameTop|
	remaining := paneMorphs reject: [:each |
			each layoutFrame bottomFraction = 1 or: [
				each layoutFrame bottomFraction = 0]].
	[remaining notEmpty] whileTrue: [
		targetBottom := remaining first layoutFrame bottomFraction.
		sameBottom := remaining select: [:each |
			each layoutFrame bottomFraction = targetBottom].
		sameTop := paneMorphs select: [:each |
			each layoutFrame topFraction = targetBottom].
		remaining := remaining
			copyWithoutAll: (self addPaneHSplitterBetween: sameBottom and: sameTop)]! !

!PanelMorphWithSplitters methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 15:12'!
addPaneSplitters
	"Add the vertical and horizontal pane splitters."
	
	self removePaneSplitters.
	self addPaneVSplitters.
	self addPaneHSplitters.
	self linkSplittersToSplitters! !

!PanelMorphWithSplitters methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 14:54'!
addPaneVSplitterBetween: leftMorphs and: rightMorphs
	"Add a vertical splitter for the given morphs that share a common right fraction.
	If there is a vertical discontinuity apply the splitter to the first contiguous group.
	Answer the morphs to which the splitter was applied."
	
	|targetX fixed bottomFraction topFrame bottomFrame sorted morph leftGroup rightGroup splitter offset|
	leftMorphs ifEmpty: [^self].
	targetX := leftMorphs first layoutFrame rightFraction.
	fixed := leftMorphs select: [:m | m layoutFrame leftFraction = m layoutFrame rightFraction].
		"fixed morphs appear in both top and bottom"
	sorted := ((leftMorphs reject: [:m | m layoutFrame leftFraction = m layoutFrame rightFraction])
		asSortedCollection: [:a :b | a layoutFrame bottomFraction = b layoutFrame bottomFraction
			ifTrue: [a layoutFrame topFraction <= b layoutFrame topFraction]
			ifFalse: [a layoutFrame bottomFraction <= b layoutFrame bottomFraction]]) readStream.
	sorted contents ifEmpty: [^fixed].
	leftGroup := OrderedCollection new.
	bottomFraction := sorted contents first layoutFrame topFraction.
	[sorted atEnd or: [morph := sorted next.
			morph layoutFrame topFraction ~= bottomFraction and: [
				morph layoutFrame bottomFraction ~= bottomFraction]]] whileFalse: [
		leftGroup add: morph.
		bottomFraction := morph layoutFrame bottomFraction].
	topFrame := leftGroup first layoutFrame.
	bottomFrame := leftGroup last layoutFrame.
	rightGroup := (rightMorphs
			reject: [:m | m layoutFrame leftFraction = m layoutFrame rightFraction])
			select: [:m |
		m layoutFrame topFraction
			between: topFrame topFraction
			and: bottomFrame bottomFraction].
	offset := (leftGroup collect: [:m | m layoutFrame rightOffset ifNil: [0]]) max.
	splitter := ProportionalSplitterMorph new.
	splitter layoutFrame: (LayoutFrame
		fractions: (targetX @ topFrame topFraction
					corner: targetX @ bottomFrame bottomFraction)
		offsets: ((0 @ (topFrame topOffset ifNil: [0]) corner: (4@ (bottomFrame bottomOffset ifNil: [0])))
		 	translateBy: offset @ 0)).
	leftGroup := leftGroup, fixed.
	leftGroup do: [:m | splitter addLeftOrTop: m].
	rightGroup do: [:m | splitter addRightOrBottom: m].
	self addMorphBack: splitter.
	^leftGroup! !

!PanelMorphWithSplitters methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 14:51'!
addPaneVSplitters
	"Add the vertical pane splitters."

	|remaining targetRight sameRight sameLeft |
	remaining := paneMorphs reject: [:each |
			each layoutFrame rightFraction = 1 or: [
				each layoutFrame rightFraction = 0]].
	[remaining notEmpty] whileTrue: [
		targetRight := remaining first layoutFrame rightFraction.
		sameRight := remaining select: [:each |
			each layoutFrame rightFraction = targetRight].
		sameLeft := paneMorphs select: [:each |
			each layoutFrame leftFraction = targetRight and: [
				each layoutFrame rightFraction ~= targetRight]].
		remaining := remaining
			copyWithoutAll: (self addPaneVSplitterBetween: sameRight and: sameLeft)]! !

!PanelMorphWithSplitters methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/10/2012 14:54'!
initialize
	"Initialization code for PanelMorphWithSplitter"

	super initialize.

	paneMorphs := OrderedCollection new.! !

!PanelMorphWithSplitters methodsFor: 'layout-properties' stamp: 'BenjaminVanRyseghem 2/10/2012 14:49'!
layoutFrame: aFrame

	self activate.
	super layoutFrame: aFrame! !

!PanelMorphWithSplitters methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 15:12'!
linkSplittersToSplitters
	"The pane morphs are already linked. Cross link the splitters as appropriate."
	
	self splitters do: [:each |
		each splitsTopAndBottom
			ifTrue: [self splitters do: [:eachMorph |
					eachMorph splitsTopAndBottom ~= each splitsTopAndBottom ifTrue: [
						eachMorph layoutFrame bottomFraction = each layoutFrame topFraction
							ifTrue: [each addLeftOrTop: eachMorph].
						eachMorph layoutFrame topFraction = each layoutFrame bottomFraction
							ifTrue: [each addRightOrBottom: eachMorph]]]]
			ifFalse: [self splitters do: [:eachMorph |
					eachMorph splitsTopAndBottom ~= each splitsTopAndBottom ifTrue: [
						eachMorph layoutFrame rightFraction = each layoutFrame leftFraction
							ifTrue: [each addLeftOrTop: eachMorph].
						eachMorph layoutFrame leftFraction = each layoutFrame rightFraction
							ifTrue: [each addRightOrBottom: eachMorph]]]].
				
		each comeToFront.]! !
